PRINTLEVEL_GALOIS2 := 0;
_GaloisT := GaloisT;
_Galois := Galois;
_OrderGalois:= OrderGalois;
_GaloisRoots:= GaloisRoots;

GalPrint := function(arg)
   local a;
   if PRINTLEVEL_GALOIS2 >= arg[1] then
      for a in arg{[2..Length(arg)]} do 
         Print(a);
      od;   
   fi;   
end;

relgalgroup:= function(f)
   local o, sub, O, g, sub_short;
   
   o:= Order(f);
   sub:= OrderSubfield(o);
   sub_short:= OrderShort(sub[1]);
   if not sub_short = false then
      O:= OrderRelativeOrder(o,sub_short);
   else
      O:= OrderRelativeOrder(o,sub[1]);
   fi;
   
   g:=GaloisSymbT(O);
   
   return g;
   
end;

gcd:= function(re)
   local deriv, gcd;
   
   deriv:= PolyDeriv(re);
   gcd := PolyGcd(re, deriv);
   return gcd;
end;

vpoly_tschirn:= function(o, ox, f, re, func, m)
   local deriv, o, ox, O, random, alpha, t;
   
   if PolyDeg(gcd(re))=0 then
      return re;
   else
      while PolyDeg(gcd(re))>0 do
         f:= Eval(f, x+1);
         if not m = 0 then
            re:= func(f,m);
         else
            re:= func(f);
         fi;   
      od;
      return re;
   fi;
end;

Orbitlength:= function(o,ox,f,t,func,m)
   local resolv, fact, orbitlength;
   
   resolv:= vpoly_tschirn(o,ox, f, t, func, m);
   GalPrint(4, "\n*** Factoring absolute resolvent polynomial of degree ", 
           PolyDeg(resolv), " ***\n\n");
   fact:= Factor(resolv);
   orbitlength:= List(fact, g->PolyDeg(g[1]));
   Sort(orbitlength);
   
   return orbitlength;
end;


ggroup := function(deg, o, ox, f, groupspossible)
   
   local t, orbitlength, G;
   
   if Length(groupspossible)=1 then
      return groupspossible[1];
   elif deg = 13 then   
      if groupspossible[Length(groupspossible)] = 9 then
         if groupspossible = [6,9] then
            t:= GaloisMSetPol(f,3);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,3);
            if orbitlength = [52,78,156] then   
               G:= 6;
            elif orbitlength = [286] then   
               G:= 9;
            else
               Print("Error in deg13 !!!\n\n");
               G:= false;   
            fi;  
         elif groupspossible = [4,6,9] then 
            t:= GaloisMSetPol(f,2);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,2);
            if orbitlength = [26,26,26] then   
               G:= 4;
            elif orbitlength = [78] then   
               t:= GaloisMSetPol(f,3);
               orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,3);
               if orbitlength = [52,78,156] then   
                  G:= 6;
               elif orbitlength = [286] then   
                  G:= 9;
               else
                  Print("Error in deg13 !!!\n\n");
                  G:= false;   
               fi;  
            fi;   
         else
            Print("Error in deg13 !!!\n\n");
            G:= false;  
         fi;   
      elif groupspossible[Length(groupspossible)] = 8 then   
         if groupspossible = [2,5,8] or 
            groupspossible = [5,8] then
            t:= GaloisMSetPol(f,2);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,3); 
            if orbitlength = [13,13,13,13,13,13] then   
               G:= 2;
            elif orbitlength = [39,39] then   
               G:= 5;   
            elif orbitlength = [78] then    
               G:= 8;   
            else
               Print("Error in deg6 !!!\n\n");
               G:= false;   
            fi; 
         fi;
      fi;
   elif deg = 14 then
      if groupspossible[Length(groupspossible)] = 62 then
         if groupspossible = [30,62] then
            t:= GaloisMSetPol(f,3);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,3);
            if orbitlength = [182,182] then   
               G:= 30;
            elif orbitlength = [364] then 
               G:= 62;
            else
               Print("Error in deg14 !!!\n\n");
               G:= false;   
            fi;   
         else
            Print("Error in deg14 !!!\n\n");
            G:= false;  
         fi;   
      elif groupspossible[Length(groupspossible)] = 63 then
         if groupspossible = [39,63] then
            t:= GaloisMSetPol(f,4);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,4);
            if orbitlength = [182,273,546] then   
               G:= 39;
            elif orbitlength = [1001] then 
               G:= 63;
            else
               Print("Error in deg14 !!!\n\n");
               G:= false;   
            fi;   
         else
            Print("Error in deg14 !!!\n\n");
            G:= false;  
         fi;   
      fi;   
   elif deg = 15 then
      if groupspossible[Length(groupspossible)] = 103 then
         if groupspossible = [ 28, 72, 89, 103 ] then
            t:= GaloisMSetPol(f,2);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,2);
            if orbitlength = [45,60] then   
               G:= 28;
            elif orbitlength = [105] then 
               t:= GaloisMSetPol(f,3);
               orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,3);
               if orbitlength = [35,420] then   
                  G:= 72;
               elif orbitlength = [455] then 
                  G:= 103;   
               fi;
            elif orbitlength = [15,90] then 
               G:= 89;   
            else
               Print("Error in deg15 !!!\n\n");
               G:= false;   
            fi;   
         else
            t:= GaloisMSetPol(f,4);
            orbitlength:= Orbitlength(o,ox,f,t,GaloisMSetPol,4);
            if orbitlength = [30,45,60,60,90,180,180,180,180,360] then   
               G:= 20;
            elif orbitlength = [30,45,60,60,90,180,180,360,360] then 
               G:=28;
            elif orbitlength = [105,210,420,630] then 
               G:=47;
            elif orbitlength = [105,420,840] then 
               G:=72;
            elif orbitlength = [1365] then 
               G:=103;
            fi;
         fi;
      fi;
   else
      Print("Error !!!\n\n"); 
   fi;
   return G;   
end;


_GaloisT := GaloisT;
_Galois := Galois;
_GaloisRoots:= GaloisRoots;

GaloisT := function(arg)
   local a1, f, o, Zx, deg, gpl, G, g;
   
   if IsList(arg[1]) then
      arg := arg[1];
   fi;
   PRINTLEVEL_GALOIS2 := PRINTLEVEL("GALOIS");
   a1 := arg[1];

   if IsOrder(a1) then
      if not GaloisGroupKnown(arg[1]) = false then
         return GaloisGroupKnown(arg[1]);
      fi;
      o := a1;
      f := OrderPoly(o);
   elif IsPoly(a1) then
      if PolyDeg(a1) = 1 then
         o:= a1;
      else
         f := a1;
         f := PolyMakeMonicInZ(f); 
         o := Order(f);
         deg := PolyDeg(f);   
      fi;   
   else
      o := 1;
   fi;
   
   arg[1] := o;
   
   G := _GaloisT(arg);
   deg:= PolyDeg(f);   
   
   if not G = false then
      if deg = 14 and G in [12,13,20,22,23,24,25,31,32,36,37,45] then
         GalPrint(4, "\n*** used lower bounds -- prove the result ***\n\n");
         PRINTLEVEL("GALOIS", 0);
         g:= relgalgroup(f);
         PRINTLEVEL("GALOIS", PRINTLEVEL_GALOIS2);
         if g in [2,4] then
            GalPrint(1, "\n====================================================");
            GalPrint(1, "\nThe Group is ",G, "\n\n");
            return G;
         else
            G:= false;
            return G;   
         fi;   
      else
         GalPrint(1, "\n====================================================");
         GalPrint(1, "\nThe Group is ",G, "\n\n");
         return G;
      fi;   
   fi;
   

   Zx := PolyAlg(f);
   gpl := GaloisGroupsPossible(o);
   GalPrint(4, "\n\n\n*** Index [G:H] too large - use other method ***\n");
   G := ggroup(deg, o, Zx, f, gpl);
   GalPrint(1, "\n\nThe Galois group is ",G, "\n\n");
   GaloisGroupSet(arg[1], G);
   return G;
   
end;

Galois := function(arg)
   local deg, G;
   
   if IsOrder(arg[1]) then
      deg:= OrderDeg(arg[1]);
   elif IsPoly(arg[1]) then
      deg:= PolyDeg(arg[1]);
   else
      Print("something is wrong\n");
   fi;
   G:= GaloisT(arg);

   return GaloisNumberToName(deg, G);
end;


OrderGalois := function(arg)
   local deg, G;
   
   if IsOrder(arg[1]) then
      deg:= OrderDeg(arg[1]);
   elif IsPoly(arg[1]) then
      deg:= PolyDeg(arg[1]);
   else
      Print("something is wrong\n");
   fi;
   G:= GaloisT(arg);

   return GaloisNumberToName(deg, G);
end;

GaloisRoots:= function(arg)
   local g, k;
   
   if IsList(arg[1]) then
      arg := arg[1];
   fi;
   
   if not IsOrder(arg[1]) then
      return Error("usage: GaloisRoots( <order> [, <integer>] )");
   fi;
   if Length(arg) = 1 then
      return _GaloisRoots(arg[1]);
   elif Length(arg) = 2 then
      g:= GaloisRing(arg[1]);
      if not IsInt(arg[2]) then
         return _GaloisRoots(arg[1], arg[2]);
      fi;
      if IsOrder(g[1]) or g[1] = Z then
         return _GaloisRoots(arg[1], arg[2]);
      else
         k:= arg[2];
         Prec(k);
         return _GaloisRoots(arg[1], arg[2]);
      fi;
   else
      return Error("usage: GaloisRoots( <order> [, <integer>] )");
   fi;
end;










