Newton3 := function(elt, deg, o) # EltMinPoly by lin. alg.
  local L, i, j, m, me, den;

  me := EltToList(elt);
  IsMat(me);
  me := MatTrans(me);
  m := EltRepMat(elt);
  if m[1]<>1 then m := m[2]/m[1];
  else m := m[2];
  fi;
  L := [EltToList(Elt(XEltOrder(elt), 1)), Copy(me)];
  IsMat(L[1]);
  L[1] := MatTrans(L[1]);

  for i in [3..deg+1] do
    L[i] := m * L[i-1];
    Info("Newton3: Step ", i, "\n");
  od;
  Apply(L, i->MatToColList(i)[1]);

  while not IsInt(L[1][1]) and not IsRat(L[1][1]) and XEltOrder(L[1][1])<>o do
    Apply(L, i->Flat(List(i, EltToList)));
  od;
  den := function(a)
    if IsRat(a) then
      return Denominator(a);
    elif IsInt(a) then
      return 1;
    else
      return EltDen(a);
    fi;
  end;
  den := Lcm(List(L, i->Lcm(List(i, den))));
  IsMat(L);
  if o=Z or o=Q then 
    L := MatKernel(L);
  else
    L := ModKernel(L, true);
  fi;
  if L=false or MatRows(L)>1 or MatRows(L)=0 then return false; fi;
  L := MatToRowList(L)[1];
  L := Reversed(L);
  if L[1]<>1 then L := (1/L[1])*L; fi;
  return [Poly(PolyAlg(o), L), den];
end;
