StringArg := function(a,b)
  local i, j, k;

  if Position(a, b)<>false then
    return true;
  else
    return false;
  fi;
end;

if not IsBound(Info) then
  Info := Ignore;
fi;
# no hom   without automorphisms into Oa
# with s   returns s and Oa
# try all  for normal fields: tries to combine all automorphsims
# normal   if Oa is normal
RelOrderAbsWithAutomorphisms := function(arg)
  local o, ox, oo, P, Q, R, g, gamma, alpha, beta, s, Oa, Oax,
        sqfr_norm, i, n, O, m, el, L, b, mn, l, den, p, x, y, g,
        autO, auto, j, autOa;

  if IsList(arg[1]) then arg := arg[1]; fi;

  sqfr_norm := function()
    local x, y, z;
    x := Poly(ox, [1,0]);
    s := -1;
    repeat
      s:= s+1;
      Info("S now: ", s, "\n");
      g := Eval(Q, x-s*alpha);
      g := PolyToList(g);
      Apply(g, EltSimplify);
      g := Poly(PolyAlg(XEltOrder(g[1])), g);
      R := Norm(g);
      y := PolyDeriv(R);
      z := Runtime();
      y := PolyGcd(R, y);
      Info("Time for Gcd(f, f'): ", Runtime()-z, "\n");
    until PolyDeg(y)=0;
  end;

  O := arg[1];
  O := OrderEquationOrder(O);
  oo := XOrderCoefOrder(O);

  o := OrderEquationOrder(oo);
  oo := XOrderCoefOrder(oo);

  ox := PolyAlg(o);
  P := OrderPoly(o);
  Q := PolyMove(OrderPoly(O),o );
  alpha := OrderBasis(o)[2];

  sqfr_norm();
  y := KASHLEVEL("KASH_ORDER_POLY_FACTOR");
  KASHLEVEL("KASH_ORDER_POLY_FACTOR", 0);
  Oa := Order(R);
  y := KASHLEVEL("KASH_ORDER_POLY_FACTOR", y);

  if StringArg(arg{[2..Length(arg)]}, "no hom") then
    if StringArg(arg{[2..Length(arg)]}, "with s") then
      return [Oa, s];
    else
      return Oa;
    fi;
  fi;
  y := Runtime();
  if oo<>Z then
    if OrderIsMaximal(XOrderCoefOrder(Oa)) then
      den := OrderDisc(Oa);
    else
      den := PolyDisc(OrderPoly(Oa));
    fi;
  else
    den := PolyDisc(R);
  fi;
  Info("Time for PolyDisc : ", Runtime()-y, "\n");

  if oo<>Z then
    den := XIdealMin(den*oo)* OrderDisc(oo);
    p := NextPrime(7*OrderDegAbs(oo));
  else
    p := NextPrime(XOrderDeg(Oa));
  fi;
  while (den mod p)=0 do p := NextPrime(p); od;
  Info("Prime : ", p, "\n");


  alpha := XEltMove(OrderBasis(o)[2], O);
  beta := OrderBasis(O)[2];
  gamma := (s*alpha+beta) mod p;

  L := [];
  mn := XOrderDeg(o)*XOrderDeg(O);
  el := Elt(O, 1);

  for i in [0..mn-1] do
    l := EltToList(el);
    Apply(l, EltToList);
    l := Flat(l);
    Add(L, l);
    if i <mn-1 then
      el := (el*gamma) mod p;
    fi;
  od;

  b := Flat(List(EltToList(alpha), EltToList));

  if oo=Z then
    m := List(L, x->List(x, y->y mod p));
    m := MatTrans(Z, m);
    m := MatMove(m, FF(p));
    l := MatTrans(Z, [List(b, x->x mod p)]);
    l := MatMove(l, FF(p));
    l := m^-1*l;
    l := MatMove(l, Z);
    ox := [MatToColList(l)[1]];
  else
    P := Factor(p*oo);
    ox := [];
    for i in P do
      m := List(L, x->List(x, y->XEltToFFE(y, i[1])));
      m := MatTrans(FFEltFF(m[1][1]), m);
      l := List(b, x->XEltToFFE(x, i[1]));
      l := m^-1*MatTrans(FFEltFF(l[1]), [l]);
      l := List(MatToColList(l)[1], x->XFFEToElt(x, i[1]));
      Add(ox, l);
    od;

    for i in [2..Length(P)] do
       for x in [1..mn] do
         ox[1][x] := IdealChineseRemainder(P[i][1], P[1][1], ox[i][x], ox[1][x]) mod p;
       od;
       P[1][1] := P[1][1]*P[i][1];
    od;
  fi;
  alpha := Elt(Oa, ox[1]);
  g := OrderPoly(o);

  if Eval(g, alpha) mod p <>0 then Error("s.th. went wrong"); fi;
  y := Runtime();
  Info("Start Newton...\n");
  x := 10;
  repeat
    beta := EltNewtonLift(Oa, alpha, g, p, x, true);
    x := x+1;
    if x>19 then Error("bin zu dumm"); fi;
  until beta<>false;
  alpha := beta;
  Info("Newton time : ", Runtime()-y, "\n");

  if Eval(PolyMove(OrderPoly(o), Oa), alpha)<>0 then Error("wrong embedding"); fi;
  OrderInstallHom(o, Oa, alpha);

  beta := OrderBasis(Oa)[2]-s*alpha;

  if Eval(PolyMove(OrderPoly(O), Oa), beta)<>0 then Error("wrong embedding"); fi;

  OrderInstallHom(O, Oa, beta);
  beta := OrderBasis(O)[2]+s*OrderBasis(o, O)[2];

  if Eval(PolyMove(OrderPoly(Oa), O), beta)<>0 then Error("wrong embedding"); fi;

  OrderInstallHom(Oa, O, beta);
  OrderInstallHom(O, Oa, true);

  autO := OrderAutomorphisms(O, []);
  auto := OrderAutomorphisms(XOrderCoefOrder(O), [])*s;
  if not StringArg(arg{[2..Length(arg)]}, "try all") and
     not StringArg(arg{[2..Length(arg)]}, "normal") then
    auto := [auto[1]];
  fi;
  autOa := [];
#  Print("afang Apply\n");
  Apply(auto, i->XEltMove(i, Oa));
#  Print("mitte Apply\n");
  Apply(autO, i->XEltMove(i, Oa));
#  Print(auto, "\n\n\n", autO, "\n\n\n\n");
#  Print("ende Apply\n");
  for i in auto do
    for j in autO do
      Add(autOa, i+j);
    od;
  od;

  if StringArg(arg{[2..Length(arg)]}, "try all") then
    autOa := Filtered(autOa, i->Eval(OrderPoly(Oa), i)=0);
  fi;
  OrderAutomorphisms(Oa, autOa);
  if StringArg(arg{[2..Length(arg)]}, "with s") then
    return [Oa, s];
  else
    return Oa;
  fi;
end;
