RelOrderMergeWithAutomorphisms := function(arg)
  local i1, i2, O, b1, b2, m, i, bo, b, j, y, s, O1, O2;

  if IsList(arg[1]) then arg := arg[1]; fi;

  O1 := arg[1];
  O2 := arg[2];

  if XOrderCoefOrder(O1)<>XOrderCoefOrder(O2) then
    Error("O1 and O2 must be over the same order");
  fi;

  O1 := OrderSimplify(O1);
  O2 := OrderSimplify(O2);

  O  := Order(PolyMove(OrderPoly(O1), O2));
  OrderInstallHom(O1, O, OrderBasis(O)[2]);
  i1 := OrderAutomorphisms(O1, []);
  Apply(i1, i->XEltMove(i, O));
  OrderAutomorphisms(O, i1);
  O  := RelOrderAbsWithAutomorphisms(Concatenation([O], ["normal"],
                                                       arg{[3..Length(arg)]}));

  if StringArg(arg{[3..Length(arg)]}, "fields") then
    return O;
  fi;

  if StringArg(arg{[3..Length(arg)]}, "with s") then
    s := O[2];
    O := O[1];
  fi;


  b1 := OrderBasis(O1, O);
  if XOrderCoefOrder(O1)=Z then
    i1 := List(b1, m->1);
  else
    i1 := OrderCoefIdeals(O1);
  fi;
  b2 := OrderBasis(O2, O);
  if XOrderCoefOrder(O2)=Z then
    i2 := List(b1, m->1);
  else
    i2 := OrderCoefIdeals(O2);
  fi;
  m := Length(b1);
  b := [];
  i := [];
  for j in [1..m] do
    Append(b, b1[j]*b2);
    Append(i, i1[j]*i2);
  od;

  if XOrderCoefOrder(O1)=Z then
    i1 := Lcm(List(b, EltDen));
    b := b*i1;
    Apply(b, EltToList);
    b := MatTrans(Z, b);
    O := Order(O, b, i1);
    if Gcd(OrderDisc(O1), OrderDisc(O2))=1 then
      OrderSetMaximal(O);
    fi;
  else
    O := Order(O, MatTrans(XOrderCoefOrder(O), List(b, EltToList)), i);

    if OrderIsMaximal(O1) and OrderIsMaximal(O2) and
       OrderDisc(O1)+OrderDisc(O2)=1*XOrderCoefOrder(O) then
       OrderSetMaximal(O);
    fi;
  fi;

  if StringArg(arg{[3..Length(arg)]}, "with s") then
    return [O, s];
  else
    return O;
  fi;
end;
