EvalMod := function(poly, at, M)
  local i, value, coefs, j;
 
  coefs := PolyToList(poly mod M);
  if IsList(at) then
    j := Length(coefs);
    value := 0;
    for i in [1..j] do
      value := (value + (at[j-i+1] mod M) *coefs[i]) mod M;
    od;
    return value;
  fi;
  value := coefs[1];
  for i in [2 .. Length(coefs)] do
    value := (at * value + coefs[i]) mod M;
  od;
 
  return  value;
end;


if not IsBound(IntRoot) then
  IntRoot := function(a,b)
    local p;
    if Log(a)<1000 then
      p := Prec();
      Prec(Floor(Log(a)/Log(10))+20);
      a := Floor(a^(1/b));
      Prec(p);
      return a;
    fi;
    return 1;
  end;
fi;

  
EltRoot2 := function(arg)
  local g, p, lp, i, f, nop, j, k, l, m, aut, nmu, den, mu, deg, EltLift, x;
  
  x := Poly(Zx, [1,0]);
  EltLift := function(ff, a, p)
    local A, hh, ww, gww, kk, M, i, j, g, rt, ib, QRound, f, den,
          IdealPower, ll, min, min2, o, b, EvalMod, x;

    den := 1;
    f := ff;
   
    x := Poly(Zx, [1,0]);
    
    if not IsInt(p) and not XIdealDegree(p)=XOrderDeg(XEltOrder(a)) then
      f := PolyToList(ff);
      if PolyAlg(ff)<>Zx and ForAny(List(f, EltDen), i->i<>1) then
        den := Lcm(List(f, EltDen));
        f := Eval(ff, x/den) * den ^ PolyDeg(ff);
        a := a*den mod p;
      else 
        f := ff;
      fi;
    fi;

    EvalMod := function(poly, at, M, min)
      local i, value, coefs, j;

      coefs := PolyToList(poly mod M);
      if IsList(at) then
        j := Length(coefs);
        value := 0;
        for i in [1..j] do
          value := (value + (at[j-i+1] mod min) *coefs[i]) mod min;
        od;
        return value;
      fi;
      value := coefs[1];
      for i in [2 .. Length(coefs)] do
        value := (at * value + coefs[i]) mod min;
      od;

      return  value;
    end;

    QRound := function(q)
      local qr;
      if Numerator(q) mod Denominator(q) > Denominator(q)/2 then
        qr := IntQuo(Numerator(q), Denominator(q)) +1;
      else
        qr := IntQuo(Numerator(q), Denominator(q));
      fi;
      return qr;
    end;
    
    IdealPower:=function(id, k)
      local idk, L, o, p, eq_o;  

      return id^(2^k);
      o:=XIdealOrder(id);
      eq_o:=OrderEquationOrder(o);
      p:=XIdealMin(id);

      if XIdealDegree(id) = XOrderDeg(o) then
        return p^(2^k);
      fi;

      L:=OrderPolyHenselLift(eq_o,1,p,k);#das XIdeal korresp. zum ersten Faktor...
      if PolyDeg(L[1]) = XOrderDeg(eq_o) then
        idk := p^(2^k)*o;
      else
        idk:=XIdeal(p^(2^k),Eval(L[1],OrderBasis(eq_o,o)[2]));
      fi;
      return idk;
    end;

    if EvalMod(ff, a, p, p)<>0 then Error("wrong start value"); fi;

    rt := Runtime();
    g := PolyDeriv(f);
    A := a mod p;
    min := p;
    o := (1/(EvalMod(g, A, p, min))) mod min;
    kk := 1; 
    M := IdealPower(p,kk);
    min := p^2;
    A := a mod M;
    b := (A-o*EvalMod(f, A, M, min)) mod min;
    while true do
      kk := kk+1;
      gww := [1, b];
      min2:=min^2;
      M := min2;
      for i in [2..PolyDeg(f)+1] do
        gww[i] := (gww[i-1]*b) mod min2;
      od;

      o := (o*(2-o*EvalMod(g, gww, M, min)) mod min) mod min;
      min:=min2;
      b := (b-o*EvalMod(f, gww, M, min)) mod min;

      ww := b;
      if IsInt(M) or XIdealDegree(p) = XOrderDeg(XEltOrder(a)) then
        if IsInt(M) then
          A := M;
        else
          A := XIdealMin(M);
        fi;
        gww := EltToList(ww);
        if IsElt(gww[1]) then
          Apply(gww, EltToList);
          Apply(gww, i->List(i, j->RationalReconstruct(j, A)));
          Apply(gww, i->Elt(XOrderCoefOrder(XEltOrder(a)), i));
        else
          Apply(gww, i->RationalReconstruct(i, A));
        fi;
        gww := Elt(XEltOrder(a), gww);
      else
        ll := PRINTLEVEL("LLL");
        PRINTLEVEL("LLL", 1);
        rt := Runtime();
        ib := MatMLLL(XIdealBasis(M)[2]); 
        A := ib[2];
        ib := ib[1];
        PRINTLEVEL("LLL", ll);
        Info("LLL time: ", (Runtime()-rt)/1000.0, "\n");
        rt := Runtime();
        gww := MatTrans(Q, [EltToList(ww)]);
        ll := MatSolve(ib, gww)[1];
        ll := MatToColList(ll)[1];
        Info("Solve time: ", (Runtime()-rt)/1000.0, "\n");
        rt := Runtime();
        Apply(ll, QRound);
        ll := MatTrans(Z, [ll]); 
        gww := gww - ib*ll; 
        gww := MatToColList(gww)[1];
        gww := Elt(XEltOrder(a), gww); 
        Info("Round time: ", (Runtime()-rt)/1000.0, "\n");
      fi;
      rt := Runtime();
      if Eval(ff, gww/den) = 0 then
        Info("Finish: ", (Runtime() - rt)/1000.0, "\n");
        return gww/den;
      fi;
      Info("Eval: ", (Runtime() - rt)/1000.0, "\n");

      if (kk>14) then Error("probably no lift... "); fi;

      GASMAN("g");
    od;
  end;
 
  Info("Root2 called\n");

  mu := arg[1];
  deg := arg[2];
  p := deg+1;

  if Length(arg)>2 then
    nmu := Norm(arg[3])*EltDen(arg[1]);
  else
    nmu := Norm(mu);
    nmu := nmu * Denominator(nmu)^2;
  fi;   

  repeat
    p := NextPrime(p);
    while nmu mod p = 0 or 
          XDisc(OrderEquationOrder(XEltOrder(mu))) mod  p = 0 
                do 
      p := NextPrime(p);
    od;

    lp := Factor(XEltOrder(mu)*p);
    lp := lp[1][1];

    f := x^deg-XEltToFFE(mu, lp);
    g := f;
    f := Factor(f);
    if ForAny(f, i->PolyDeg(i[1])>1) then
      Info("left\n");
      return false;
    fi;
  until ForAll(f, i->i[2]=1);

  f := -PolyToList(f[1][1])[2];
  f := XFFEToElt(f, lp);

  mu := EltSimplify(mu);
  den := EltDen(mu);
  mu := mu*den;
  mu := EltSimplify(mu);
  aut := IntRoot(den, deg);
  if aut^deg - den =0 then
    f := (f*aut) mod lp;
    return EltLift(x^deg-mu, f, lp)/aut;
  else
    Info("SHIT\n");
    i := Factor(den);
    g := 1;
    den := 1;
    aut := 1;
    for j in i do
      g := g * j[1]^(IntQuo(j[2], deg));
      den := den * j[1];
      aut := aut * j[1]^(deg-(j[2] mod deg));
    od;
    f := (f*g*den) mod lp;
    return EltLift(x^deg-mu*aut, f, lp)/g/den;
  fi;
end;

    
