if not IsBound(RelOrderAbsWithAutomorphisms) then
  ReadLib("RCLF/RelExt4");
fi;
if not IsBound(RelOrderMergeWithAutomorphisms) then
  ReadLib("RCLF/RelMerge");
fi;

OrderSubfieldFromElements := function(arg)
  local o, O, n, i, j, k, l, x, L, f;

  l := arg[1];
  O := XEltOrder(l[1]);
  if Length(arg)>1 then
    n := arg[2];
  else
    n := XOrderDeg(O);
  fi;

  L := [Elt(O, 1)];
  i := 1;
  repeat
    k := [];
    j := Elt(O, 1);
    repeat
      Append(k, List(j*L, EltToList));
      j := j*l[i];
      IsMat(k);
    until Length(MatKernel(k))>0;
    k :=k{[1..Length(k)-Length(L)]};
    IsMat(k); k := MatToRowList(k);
    L := List(k, x->Elt(O, x));
    i := i+1;
  until Length(L)=n or i>Length(l);

  n := Length(L);
  i := MultiCounterInit(n);
  repeat
    if not MultiCounterInc(i, 1) then
      Error("s.th. went wrong");
    fi;
    j := i*L;
    f := EltMinPoly(j);
  until PolyDeg(f)=n;

  o := Order(f);
  OrderInstallHom(o, O, j);
  GASMAN("g");

  return o;
end;


OrderMergeWithAutomorphisms := function(arg)
  local o, oi, o1r, o2r, O, i, jj, j, k, l, m, n, f, Oa, klf, s, O1, O2;

  if IsList(arg[1]) then arg := arg[1]; fi;
  O1 := arg[1];
  O2 := arg[2];

  klf := KASHLEVEL("factor");
  KASHLEVEL("factor", 0);
  o := XOrderCoefOrder(O1);
  if o<>XOrderCoefOrder(O2) then
    Error("must have same coef Order");
  fi;

  if (o=Z and IntGcd(XDisc(O1), XDisc(O2)) = 1) or
     (o<>Z and XDisc(O1)+XDisc(O2)=1*o) then
      f := [[PolyMove(OrderPoly(O2), O1), 1]];
  else
    f := Factor(PolyMove(OrderPoly(O2), O1));
  fi;
  if Length(f)=1 then
    oi := Z;
    O := RelOrderMergeWithAutomorphisms(Concatenation([O1, O2],
                                              arg{[3..Length(arg)]},
                                              ["normal"]));
    KASHLEVEL("factor", klf);
    return [oi, O, O1, O2];
  fi;

  f := f[1][1];

  if PolyDeg(f) = 1 then
    return [O1, O1, O1, O1];
  fi;

  oi := OrderSubfieldFromElements(PolyToList(f), XOrderDeg(O2)/PolyDeg(f));
  if XOrderDeg(oi)<XOrderDeg(O1) then
    o1r := OrderRelativeOrder(O1, oi);
  else
    oi := O1;
    j := PolyMove(OrderPoly(O1), O2);
    j := Factor(j);
    j := Filtered(j, i->PolyDeg(i[1])=1);
    j := -PolyToList(j[1][1])[2];
    OrderInstallHom(OrderEquationOrder(O1), O2, j);
    #
    #
    # OrderIsSubfield(O1, O2);
  fi;

  o2r := Order(PolyMove(f, oi));
  i := OrderAbs(o2r);
  OrderInstallHom(i, OrderEquationOrder(O2),
                                      OrderBasis(OrderEquationOrder(O2))[2]);
  OrderInstallHom(OrderEquationOrder(O2), i, OrderBasis(i)[2]);
  OrderInstallHom(O2, i, true);

  if XOrderDeg(oi)<XOrderDeg(O1) then

    i := OrderAutomorphisms(O1, []);
    k := XEltMove(OrderBasis(oi)[2], O1);
    i := Filtered(i, j->EltAutomorphism(k, j)=k);
    k := XEltMove(OrderBasis(o1r)[2], O1);
    i := List(i, j->XEltMove(EltAutomorphism(k, j), o1r));
    OrderAutomorphisms(o1r, i);

    i := OrderAutomorphisms(O2, []);
    k := XEltMove(OrderBasis(oi)[2], O2);
    i := Filtered(i, j->EltAutomorphism(k, j)=k);
    k := XEltMove(OrderBasis(o2r)[2], O2);
    i := List(i, j->XEltMove(EltAutomorphism(k, j), o2r));
    OrderAutomorphisms(o2r, i);

    O := RelOrderMergeWithAutomorphisms(Concatenation([o1r, o2r],
                                              arg{[3..Length(arg)]},
                                              ["normal", "with s"]));
    s := O[2];
    O := O[1];


    i := OrderAutomorphisms(O2, []);
    j := OrderAutomorphisms(O1, []);
    k := XEltMove(OrderBasis(oi)[2], O2);
    l := XEltMove(OrderBasis(oi)[2], O1);

    i := Filtered(i, x->EltAutomorphism(k, x)<>k);
    for f in [1..Length(i)] do
      if i[f]<>false then
        for m in [f+1..Length(i)] do
          if i[f]<>false and
             EltAutomorphism(k, i[f])=EltAutomorphism(k, i[m]) then
            i[f] := false;
          fi;
        od;
      fi;
    od;
    i := Filtered(i, f->f<>false);
    k := List(i, x->XEltMove(EltAutomorphism(k, x), oi));
    OrderAutomorphisms(oi, k);

    for f in [1..Length(i)] do
      m := XEltMove(k[f], O1);
      jj := Filtered(j, x->EltAutomorphism(l, x)=m);
      if jj<>[] then
        i[f] := XEltMove(i[f], O)*s+ XEltMove(jj[1], O);
      else
        i[f] := false;
      fi;
    od;

    i := Filtered(i, IsElt);

    Oa := RelOrderAbsWithAutomorphisms(Concatenation([O], 
                                                      arg{[3..Length(arg)]}));
    l := [];
    for j in [1..Length(i)] do
      s := XEltMove(OrderBasis(OrderEquationOrder(Oa))[2],
                                                       OrderEquationOrder(O));
      s := EltToList(s);
      Apply(s, x->EltAutomorphism(x, k[j]));
      s := Poly(PolyAlg(oi), Reversed(s));
      Add(l, XEltMove(Eval(s, i[j]), Oa));
    od;
    k := OrderAutomorphisms(Oa, []);
    j := Copy(l);
    for i in [2..Length(k)] do
      Append(j, List(l, x->EltAutomorphism(x, k[i])));
    od;
    OrderAutomorphisms(Oa, j);

  else
    o2r := OrderRelativeOrder(O2, O1);
    oi := O1;
    O := o2r;
    o1r := O1;
  fi;

  KASHLEVEL("factor", klf);
  return [oi, O, o1r, o2r];

end;

