if not IsBound(Info) then
  Info := Ignore;
fi;

RelOrderMax := function(O)
  local Oa, Oe, Ot, index, i, bO, bo, b, Om, pl, m, Info;

Info := Ignore;

  Info("Starting OrderAbs\n");
  Oe := OrderAbs(O);
  if OrderIsMaximal(Oe) then
    Info("OK\n");
    if OrderIsMaximal(O) then
      return Oe;
    else
      return OrderMaximal(O);
    fi;
  fi;
  Info("AbsPoly is: ", OrderPoly(Zx, Oe), "\n");
  Info("AbsDisc is: ", PolyDisc(OrderPoly(Zx, Oe)), "\n");

  bO := OrderBasis(O);
  if OrderIsMaximal(O) then
    b := [];
  else
    b := OrderBasis(Oe);
  fi;

  m := Length(bO);
  for i in [1..m] do
    bo := IdealBasis(OrderCoefIdeals(O)[i]);
    bo[2] := MatToColList(bo[2]);
    Apply(bo[2], index->Elt(OrderCoefOrder(O), index)/bo[1]);
    Append(b, bO[i]*bo[2]);
  od;
  Apply(b, index->EltMove(index, Oe));

  if OrderIsMaximal(O) then
    i := 1;
    for m in b do
      i := IntLcm(i, EltDen(m));
    od;
    b := b*i;
    Apply(b, EltToList);
    b := MatTrans(Z, b);
    Oa := Order(Oe, b, i);
    OrderSetMaximal(Oa);
    return Oa;
  fi;

  Oa := Order(Oe, b);

  Info("AbsDisc is: ", OrderDisc(Oa), "\n");
  Info("RelDisc is: ", OrderDisc(O), "\n");
  Info("with Min  : ", IdealMin(OrderDisc(O)), "\n");

  index := Factor(OrderDisc(O));
  Info("Factorization of rel.disc:\n", index, "\n");

  pl := [];
  for i in index do
    if i[2]>1 then
      Add(pl, IdealMin(i[1]));
    fi;
  od;
  pl := Set(pl);

  Info(pl, "\n");

  for i in pl do
    Info(i, "maximal...\n");
    Ot := OrderPMaximal(Oe, i);
    Oa := Order(Oa, OrderBasis(Ot, Oa));
    Oa := OrderSimplify(Oa);
    Info("OK\n");
  od;
  OrderSetMaximal(Oa);

  Info("RelNf...\n");
  Om := OrderMaximal(O);
  Info("OK\n");
  Info("Index: ", OrderDisc(O)/OrderDisc(Om), "\n");

  return Om;
end;

RelOrderMerge := function(O1, O2)
  local i1, i2, O, b1, b2, m, i, bo, b, j, y, Info;

  Info := Ignore;

  if OrderCoefOrder(O1)<>OrderCoefOrder(O2) then
    Error("O1 and O2 must be over the same order");
  fi;

  O1 := OrderSimplify(O1);
  O2 := OrderSimplify(O2);

  O  := Order(PolyMove(OrderPoly(O1), O2));
  OrderInstallHom(O1, O, OrderBasis(O)[2]);
  O  := OrderAbs(O);

  b1 := OrderBasis(O1, O);
  if OrderCoefOrder(O1)=Z then
    i1 := List(b1, m->1);
  else
    i1 := OrderCoefIdeals(O1);
  fi;
  b2 := OrderBasis(O2, O);
  if OrderCoefOrder(O2)=Z then
    i2 := List(b1, m->1);
  else
    i2 := OrderCoefIdeals(O2);
  fi;
  m := Length(b1);
  b := [];
  i := [];
  for j in [1..m] do
    Append(b, b1[j]*b2);
    Append(i, i1[j]*i2);
  od;

  if OrderCoefOrder(O1)=Z then
    m := PRINTLEVEL("gen_proof");
    if OrderIsMaximal(O1) and OrderIsMaximal(O2) and
      IntGcd(OrderDisc(O1),OrderDisc(O2))=1 then
      PRINTLEVEL("gen_proof", 0);
      O := Order(O, b);
      OrderSetMaximal(O);
    else
      m := PRINTLEVEL("gen_proof");
      PRINTLEVEL("gen_proof", 1);
      O := Order(O, b);
    fi;
    PRINTLEVEL("gen_proof", m);
  else
    m := Module(i, MatTrans(OrderCoefOrder(O), List(b, EltToList)));
    y := Runtime();
    Print("Start ModuleNf\n");
    m := ModuleNF(m, 1*OrderCoefOrder(O));
    Print("Stop ModuleNf, time : ", Runtime()-y, "\n");
    O := Order(O, ModuleMatrix(m), ModuleIdeals(m));

    if OrderIsMaximal(O1) and OrderIsMaximal(O2) and
       OrderDisc(O1)+OrderDisc(O2)=1*OrderCoefOrder(O) then
       OrderSetMaximal(O);
    fi;
  fi;
  return O;
end;

RelOrderHNF := function(O)
  local m, o;

  o := OrderCoefOrder(O);
  O := OrderSimplify(O);
  m := OrderTransformationMatrix(O);
  m := Module(m[1], m[2]);
  m := ModuleNF(m, 1*o);
  o := Order(OrderEquationOrder(O), ModuleMatrix(m), ModuleIdeals(m));
  if OrderIsMaximal(O) then OrderSetMaximal(o); fi;
  return o;
end;

