VERLIB := "KANT V4 1999/10/01 ; GAP v3r3p0 1993/11/09";
if not IsBound( VERSRC ) then  VERSRC := "unknown";  fi;
if not IsBound( VERSYS ) then  VERSYS := "unknwon";  fi;

VERSION := [];
Append( VERSION,   "lib: " );  Append( VERSION, VERLIB );
Append( VERSION, ", src: " );  Append( VERSION, VERSRC );
Append( VERSION, ", sys: " );  Append( VERSION, VERSYS );

if not QUIET and BANNER then
PR := function ( str )  Print("     ",str,"\n");  end;
PR("                                                              ");
PR("       KK      K         AAAAA         SSSSSS      HH       HH");
PR("       KK    KK        AA    AA      SS      S    HH       HH");
PR("      KK   K          AA     AA     SS            HH       HH ");
PR("     KK  KK          AA      AA     SS           HH       HH  ");
PR("     KKKK           AA      AA       SSSSS       HHHHHHHHHHH  ");
PR("    KKKK           AA       AA         SSSSS    HH       HH   ");
PR("    KK KK         AAAAAAAAAAA             SS   HH       HH    ");
PR("   KK    KK       AA       AA             SS   HH       HH    ");
PR("  KK       K     AA       AA     S      SS    HH       HH     ");
PR("  KK        KK   AA       AA nt   SSSSSS      HH       HH ell ");
PR("                                                              ");
PR("Shell of the KANT V4 Software, Oct 99 Version 2.2                   ");
PR("                                                                    ");
PR("Copyright (c) 1994-99 by Prof. Dr. M. E. Pohst,                     ");
PR("Technische Universitaet Berlin. All rights reserved.                ");
PR("                                                                    ");
PR("For registration and support send an email to kant@math.tu-berlin.de");
PR("--------------------------------------------------------------------");
PR("KANT V4 bases on Magma developed by Prof. J. Cannon,                ");
PR("Copyright (c) 1999 Prof. J. Cannon, University of Sydney.           ");
PR("Shell bases on GAP developed by Lehrstuhl D Mathematik, RWTH Aachen,");
PR("Copyright (c) 1992 Lehrstuhl D Mathematik, RWTH Aachen.             ");
PR("                                                                    ");
PR("Enter \"?\" for help and \"quit;\" to leave KASH                    ");
PR("                                                                    ");
fi;
ReadIndent := "";

if not IsBound( InfoRead1 )  then InfoRead1 := Ignore;  fi;
if not IsBound( InfoRead2 )  then InfoRead2 := Ignore;  fi;

ReplacedString := function ( string, old, new )
    local  res,  i,  k,  l;
    res := [];
    k := 1;
    l := false;
    for i  in [1..Length(string)]  do
        if string{[i..i+Length(old)-1]} = old  then
            l := i;
        fi;
        if string[i] = ';'  then
            if l <> false  then
                Append( res, string{[k..l-1]} );
                Append( res, new );
                Append( res, string{[l+Length(old)..i]} );
            else
                Append( res, string{[k..i]} );
            fi;
            k := i + 1;
            l := false;
        fi;
    od;
    if l <> false  then
        Append( res, string{[k..l-1]} );
        Append( res, new );
        Append( res, string{[l+Length(old)..Length(string)]} );
    else
        Append( res, string{[k..Length(string)]} );
    fi;
    return res;
end;

ReadPath := function ( path, name, ext, infomsg )
    local   readIndent, i, k, file, found;
    readIndent := Copy( ReadIndent );
    Append( ReadIndent, "  " );
    InfoRead1( "#I",ReadIndent,infomsg,"( \"", name, "\" )\n" );
    i := 1;
    found := false;
    while not found  and i <= Length(path)+1 do
        k := Position( path, ';', i-1 );
        if k = false  then k := Length(path)+1;  fi;
        file := path{[i..k-1]};  Append( file, name );  Append( file, ext );
        InfoRead2("#I  trying '",file,"'\n");
        found := READ( file );
        i := k + 1;
    od;
    ReadIndent := readIndent;
    if found and ReadIndent = ""  then
        InfoRead1( "#I  ",infomsg,"( \"", name, "\" ) done\n" );
    fi;
    return found;
end;

FindPath := function ( path, name, ext )
    local   i, k, file, found;
    i := 1;
    found := false;
    while found=false  and i <= Length(path)+1 do
        k := Position( path, ';', i-1 );
        if k = false  then k := Length(path)+1;  fi;
        file := path{[i..k-1]};  Append( file, name );  Append( file, ext );
        found := Open( file , "r");
        i := k + 1;
    od;
    if found<>false then Close(found); return file; fi;
    return found;
end;

FLDIN := FLDin;
Unbind(FLDin);
FLDin := function(arg)
  local tmp, name;
  if Length(arg)>0 then
    name := arg[1];
    if TYPE(name) = "KANT file" then
      return FLDIN(name);
    fi;
    if Length(arg)>2 or not IsString(name) or (Length(arg)=2 and
      not IsInt(arg[2])) then
      Error("usage: FLDin( name ) or FLDin( file )");
    fi;
  else
    return FLDIN();
  fi;
  tmp := ";";             #  first look in the given path
  Append(tmp,LIBNAME);    #  then in LIBNAME../src
  Append(tmp, "../src/"); #
  tmp := FindPath( tmp, name, "" );
  if tmp=false then
    Error("the file '",name,"' must exist and be readable");
  fi;
  if Length(arg)=2 then
    return FLDIN(tmp, arg[2]);
  else
    return FLDIN(tmp);
  fi;
end;

#/*TEX**TEX|***TEX***TEX***TEX***TEX**TEX***TEX***TEX***TEX***TEX***TEX***TEX**
#FXN       Read
#CALLING   Read(name);
#SHORTDOC  Read a file containing \KASH\ commands.
#LONGDOC   The file "name" must be both existing and readable.
#          \KASH\ looks first in the given path, then in the current directory
#          and finally in {\tt LIBNAME../src}. 
#ARGUS     name @ string
#EXAMPLE   Assume that we have a file named "in" in our current
#          working directory. First, we take a look at its contents: @ 
#          kash> Exec("cat in");
#          Time(true);
#          x := Poly(Zx, [1,0]);
#          Palg := function(O)
#            local px;
#            px := PolyAlg(O);
#            x := Poly(px, [1,0]);
#            return px;
#          end;
#
#          kash> Read("in");
#          kash> x;
#          x
#          Time: 0 ms
#
#
#**HISTORY*|*HISTORY***HISTORY***HISTORY**HISTORY***HISTORY***HISTORY***HISTORY
#
#**C***C***|***C***C***C***C***C***C**C***C***C***C***C***C***C***C***C***C***/

Read := function ( name )
    local tmp;              # CF:
    tmp := ";";             #  first look in the given path
    Append(tmp,LIBNAME);    #  then in LIBNAME../src
    Append(tmp, "../src/"); #
    if not ReadPath( tmp, name, "", "Read" )  then
     Error("the file '",name,"' must exist and be readable");
    fi;
end;

#/*TEX**TEX|***TEX***TEX***TEX***TEX**TEX***TEX***TEX***TEX***TEX***TEX***TEX**
#FXN       ReadLib
#CALLING   ReadLib(name);
#SHORTDOC  The same as Read, but here the file should be in the
#          \KASH\ lib directory and it must have the extension ``.g''.
#ARGUS     name @ string
#XREF      Read
#EXAMPLE   We will read the neq.g library. This will define a function
#          solving norm equations by suitable principal ideal tests. @ 
#          kash> ReadLib("neq");
#          kash> Neq(o, 7);
#          Prime 7: 1 [ 2 ]
#          No solution
#          false
#          Time: 40 ms
#          kash> Neq(o, 11);
#          Prime 11: 1 [ 1, 1 ]
#          [ [ [ [ <11, [5, 2]>, 1 ], [ <11, [8, 2]>, 1 ] ], [ 0, 1 ], [ 1, 0 ] ] ]
#          at most 2 different solutions! 
#          Ideals : [ [ <11, [5, 2]>, 1 ], [ <11, [8, 2]>, 1 ] ]
#          Ideal Basis of all (possible) solutions: [ [ <11, [8, 2]>, <11, [5, 2]> ] ] 
#          [ [1, 3], [-2, -3] ]
#          Time: 260 ms
#          kash> OrderNormEquation(o, 11, -1);
#          [ [-2, -3], [-1, -3] ]
#          Time: 180 ms
#**HISTORY*|*HISTORY***HISTORY***HISTORY**HISTORY***HISTORY***HISTORY***HISTORY
#
#**C***C***|***C***C***C***C***C***C**C***C***C***C***C***C***C***C***C***C***/

ReadLib := function ( name )
    if not ReadPath( LIBNAME, name, ".g", "ReadLib" )  then
     Error("the library file '",name,"' must exist and be readable");
    fi;
end;


##############################################################################

IsRecType := Ignore;
IsPrime := Ignore;
ReadLib("list");
ReadLib("kantdiv");
ReadLib("kantmat");
ReadLib("kantelt");
ReadLib("kantord");
ReadLib("kantidl");
ReadLib("kantpoly");
ReadLib("kantmod");
ReadLib("kantlat");
ReadLib("color");

AlffEltMinPoly := Ignore;
AlffDivisorNorm := Ignore;
ReadLib("kant");
Unbind(AlffEltMinPoly);
Unbind(AlffDivisorNorm);


#############################################################################

if IsBound(PvmGet) then
  if PvmKashIsSlave then
    ReadLib("PvmSlave");
  else
    ReadLib("PvmMaste");
  fi;
fi;

x := Poly(Zx,[1,0]);
Prec(OrderPrec());



##############################################################################

AUTO( ReadLib("HCLF"), OrderHilbert);
AUTO( ReadLib("RCLF/RayField"), RayClassField, RayClassFieldAuto, 
                             RayClassFieldArtin, BaseCreate, Intersect);

AUTO( ReadLib("ImQuad"), ImQuadHilbert, ImQuadRayField);
# ImQuadClassNum,ImQuadLegendre,ImQuadRayResidues,ImQuadResNum

AUTO( ReadLib("Random"), RandomElt, RandomOrder, RandomPoly, RandomMatrix);
AUTO( ReadLib("Cyclo"), OrderCyclotomic, OrderCyclotomicUnits,
                               IntEulerPhi, OrderCyclotomicRealSubfield);

AUTO( ReadLib("RelExt"), RelOrderMax, RelOrderMerge);


AUTO( ReadLib("db"), DbOpen, DbClose, DbQuery, DbCountQuery, DbNextOrder,
                       DbChangeNames, DbExplainQuery, DbStatistic );

AUTO( ReadLib("GALOIS/galois"), 
      GaloisBlocks);
AUTO( ReadLib("GALOIS/GaloisSymb"),
      GaloisSymbT, GaloisSymb);
ReadLib("GALOIS/galois_deg131415");

AUTO( ReadLib("Alff/alff"), Alff, AlffInit, AlffOrders, 
      AlffHermitianFunField, AlffEllipticFunField, AlffEltRepMat,
      AlffEltMinPoly, 
      AlffEltAlff, AlffOrderDeg, AlffOrderBasis, AlffIdealAlff, 
      AlffIdealBasis, AlffConstFieldSize, AlffMultiCounterInit, 
      AlffMultiCounterInc, AlffIsGlobal, AlffIsGlobalAssert, IntMoebiusMy, 
      ListSplit, FFElts, IsMatCheck, ListApplyListAdd, ListApplyMatAdd, 
      AlffMakeLinear, AlffLinearRepresent, AlffDivisorLBasis, AlffDivisorSupp, 
      AlffDivisorNorm, AlffDivisorDegOne, AlffLinearSeriesEnumEnv, 
      AlffLinearSeriesEnumNext, AlffLinearSeriesEnumElt, AlffDivisorReduction, 
      AlffDivisorLargeLDim,  AlffDivisorLargeLBasisShort, AlffDivisorPlaces,
      AlffPlaceSplit, AlffEltValuation, PolyPrimeList, 
      AlffPlaceSplitType, AlffPlacesDegOneNum, AlffPlacesNum, AlffPlacesDegOne,
      AlffPlaces, AlffPlaceRandom, AlffPlacesNonSpecial, AlffPrimeResField, 
      AlffResidueField, AlffEltEval, AlffEltLift, AlffEltResiduum, 
      IsPolyOrQfe, QfeDeriv, QfePthRoot, IsAlffDiff, 
      AlffDiffAlff, AlffDiff, AlffDiffValuation, AlffDifferentDeg, 
      AlffDifferent, AlffDiffDivisor, AlffCanonicalDivisor, AlffDiffFirstKind, 
      AlffDiffSpace, AlffDiffResiduum, AlffDifferentiation, 
      AlffEltPthRoot, AlffDiffCartier, AlffDiffCartierMatrix, 
      AlffClassGroupPRank, AlffHasseWittInvariant, AlffLPoly, AlffLPolyLift, 
      AlffLPolyRed,
      AlffDivisorsSmoothNum, AlffDivisorsSmoothRatio, AlffClassGroupGenBound,
      AlffClassGroupGenBoundStrong, AlffClassNumberApproxBound, 
      AlffClassNumberApprox, AlffClassGroup, AlffClassGroupGens, 
      AlffDivisorClassRep, AlffSUnits, AlffIdealClassGroupUnitsInfty,
      AlffWronskian, AlffWronskianOrders, AlffRamDivisor, 
      AlffWeierstrassPlaces, AlffGapNumbers);

AUTO( ReadLib("rcg"), IdealRayClassRep, RayClassGroupCyclicFactors, 
      RayClassGroup, EltRayResidueRingRep, RayResidueRingRepToElt, 
      RayResidueRingCyclicFactors, RayResidueRing, RayConductor, ZIdealCreate,
      _SecondFactorDiscreteLog, _DirectProductDiscreteLog, RayConductorTest,
      _PrimePowerDiscreteLog, _gAssureZRCG, _gAssureZRRR,
      _ZRayInfoClear);

AUTO( ReadLib("FinGroup"), AbelianGroupNumberGenerators, 
      AbelianGroupMinNumberGenerators, AbelianGroupExponent, AbelianGroupBasis,
      AbelianGroupGenerators, AbelianGroupCyclicFactors, AbelianGroupIndex,
      AbelianGroupOrder, AbelianGroupDiscreteLog, AbelianGroupDiscreteExp,
      AbelianGroupEltReduce, AbelianGroupName, AbelianGroupIsDirectProduct, 
      AbelianGroupIntersect, AbelianGroupUnite, AbelianGroupSmithCreate, 
      AbelianSubGroup, AbelianHomGroup, AbelianDualGroup, AbelianGroupEltOrder,
      AbelianGroupHomCreate, AbelianGroupEqual, AbelianGroupCreate, 
      AbelianGroupEltCreate, AbelianGroupFindSupergroups, 
      AbelianGroupFindCommonSupergroup, AbelianGroupIsSub, AbelianGroupFindHom,
      AbelianGroupEltMove, AbelianQuotientGroup, AbelianGroupHomImage, 
      AbelianGroupHomKernel, AbelianGroupCanonicalQuotient, 
      RayClassGroupToAbelianGroup, RayResidueRingToAbelianGroup, 
      AbelianGroupIsAut, AbelianGroupHomMove, AbelianFixPointGroup, 
      AbelianGroupMultiHomCreate, AbelianMultiHomGroup, 
      _AbelianGroupEltDirectToTensor, AbelianGroupMultiHomCreate, 
      _IntFastPower, _AbelianGroupExtension, AbelianDualHom, 
      AbelianRayGroupImbed);

AUTO(ReadLib("abel"), AbelianFieldToRCF, AbelianGroupEltRandom,
    AbelianGroupEnumInit, AbelianGroupEnumNext, AbelianGroupHomCreateId,
    AbelianRayClassGroupAutoCreate, FindMaximalCentralField,
    FindQuotientOfShapeEnumInit, FindQuotientOfShapeEnumNext,
    IdealPrimeCountInit, IdealPrimeCountNext, MatHermiteRowUpperTrans,
    MatIndex, RayClassFieldIsCentral, RayClassFieldIsNormal,
    MatHermiteRowUpper, MatHermiteRowReduce,
    RayClassFieldIsAbelian, RayClassFieldSplittingField, _SubgroupToQuotient);

AUTO( ReadLib("stark"), StarkUnitsHilbertClassField, StarkUnitsRealPolynom,
                        StarkUnitsHilbert, StarkUnitsPolynom );
PRINT_LEVEL_Stark:=0;

if IsBound(OrderPrintFlags) then
   OrderPrintFlags(rec(disc:=-1,reg:=-1,fac_disc:=0,unit:=-1,index:=0,
                   cg:=true,c:=false,ti:=false,td:=false,t:=false,g:=false,
	           s:=false,a:=false, ci:= true));
fi;

ReadLib("auto");
#
