#############################################################################
##
#A  kantelt.g                    KANT library              Mario Daberkow
##
#A  @(#)$Id: kantelt.g 1.00 1995/02/09 Daberkow $
##
#Y  Copyright 1995,  Prof. Dr. M. Pohst, TU - Berlin,  Germany
##
##  This file contains the algebraic element KANT functions .
##
#H  $Log: kantelt.g $
#H  Revision 1.00  1995/02/09  Daberkow
#H  added 'IsElt'
#H
##
#H  $Log: kantelt.g $
#H  Revision 1.01  1998/09/10  Mendez
#H  added 'IsFFElt'
#H
##
#############################################################################
##
#F  IsElt( <object> )  . . . checks if argument is an algebraic element
#/*TEX**TEX|***TEX***TEX***TEX***TEX**TEX***TEX***TEX***TEX***TEX***TEX***TEX**
#FXN       IsElt
#CALLING   b := IsElt(x);
#SHORTDOC  Returns true iff the argument is of type "KANT algebraic element".
#ARGUS     b @ boolean
#          x
#
#PACKAGE   lib
#
#KASH      @
#          o := Order(Z, 2, 5);;
#          IsElt(1);
#          IsElt(Elt(o, 1));
#
#**KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH*/
##


IsElt := function ( a )

  if (TYPE (a) = "KANT algebraic element") then
    return true;
  else
    return false;
  fi;
end;

#############################################################################
##
#F  IsFFElt( <object> )  . . . checks if argument is an finite field element
#/*TEX**TEX|***TEX***TEX***TEX***TEX**TEX***TEX***TEX***TEX***TEX***TEX***TEX**
#FXN       IsFFElt
#CALLING   b := IsFFElt(a);
#SHORTDOC  Returns true iff the argument is of type "KANT finite field elt".
#ARGUS     b @ boolean
#          a
#
#PACKAGE   lib
#
#KASH      @
#          k := FF(2,4);
#          a := FFElt(k,9);
#          IsFFElt(a);
#
#**KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH***KASH*/
##

IsFFElt := function ( a )

  if (TYPE (a) = "KANT finite field elt") then
    return true;
  else
    return false;
  fi;
end;



