#####################################################################
##
## more RandomPolys 
##
#####################################################################
RandomPolyZeros := function(arg)
#Zufaellig erzeugtes Polynom in Ox vom Grad d mit grossen Koeffizienten.
#Es tritt haeufiger das Element 0 auf.
local O,d,P,cs,Ox,List,i,alpha;

if Length(arg)<2 then Error(
  "usage: RandomPolyZeros(<ring>,<degree>[,<probability of zeros>,[<coef-size>]]);");
fi;

O:=arg[1];
d:=arg[2];
if Length(arg)>2 then 
  P:=arg[3]; 
  if TYPE(P)="KANT real" then
    P:=Floor(1000*P)/1000;
  fi;
  if TYPE(P)<>"rational" then
    P:=1/2;
  fi;    
else 
  P:=1/2;
fi;
  
if Length(arg)>3 then 
  cs:=arg[4]; 
else  
  cs:=134217728;
fi;

Ox := PolyAlg(O);

List := [1];
for i in [1..d] do
  if RandomList([1..Denominator(P)]) <= Numerator(P) and i<d
  then
    alpha := EltMove(0,O);
  else
    alpha := RandomElt(O, cs);
  fi;
  Append (List, [alpha]);
od;

return Poly(Ox,List);
end;


RandomPolyZ := function(O,Ox,d)
local Ox,deg,List,i,j,List2,alpha;

#Zufaellig erzeugtes Polynom in Ox vom Grad d mit grossen Koeffizienten nur Z.
deg := OrderDeg(O);
List := [1];
for i in [1..d] do
  List2 := [(RandomList([1..134217728]) * RandomList([1..134217728]))];
  for j in [2..deg] do
    Append(List2, [0] );
  od;
  alpha := Elt(O,List2);
  Append (List, [alpha]);
od;

return Poly(Ox,List);
end;


RandomPoly2 := function(O,Ox,maxdeg,maxfact)
local f,i,d,anz;

#Zufaellig erzeugtes Polynom in Ox.
#Mit maximal maxfact Faktoren, die jeweils hoechstens den Grad maxdeg haben.
anz := RandomList([1..maxfact]);
f := 1;
for i in [1..anz] do
 d := RandomList([1..maxdeg]);
 f := f*RandomPoly(O,Ox,d);
od;

return f;
end;


RandomPolyZeros2 := function(O,Ox,maxdeg,maxfact)
local f,i,d,anz;

#Zufaellig erzeugtes Polynom in Ox.
#Mit maximal maxfact Faktoren, die jeweils hoechstens den Grad maxdeg haben.
anz := RandomList([1..maxfact]);
f := 1;
for i in [1..anz] do
 d := RandomList([1..maxdeg]);
 f := f*RandomPolyZeros(O,Ox,d);
od;

return f;
end;


RandomPolyZ2 := function(O,Ox,maxdeg,maxfact)
local f,i,d,anz;

#Zufaellig erzeugtes Polynom in Ox mit Koeffizienten in Z.
#Mit maximal maxfact Faktoren, die jeweils hoechstens den Grad maxdeg haben.
anz := RandomList([1..maxfact]);
f := 1;
for i in [1..anz] do
 d := RandomList([1..maxdeg]);
 f := f*RandomPolyZ(O,Ox,d);
od;

return f;
end;


RandomPolyC2 := function(O,Ox,maxdeg,maxfact)
local f,i,d,anz;

#Zufaellig erzeugtes Polynom in Ox mit Koeffizienten in O.
#Mit maximal maxfact Faktoren, die jeweils hoechstens den Grad maxdeg haben.
#Mit Faktoren ueber Z
anz := RandomList([1..maxfact]);
f := 1;
for i in [1..anz] do
 d := RandomList([1..maxdeg]);
 if RandomList([1..2]) = 1
 then
   f := f*RandomPolyZ(O,Ox,d);
 else
   f := f*RandomPoly(O,Ox,d);
 fi;
od;

return f;
end;


RandomPolyList := function(O,n,maxdeg,maxfact)
local f,i,L,Ox;

#Liste mit zufaelligen Polynomen nur ueber O.
L:=[];
Ox := PolyAlg(O);
for i in [1..n] do
  f := RandomPoly2(O,Ox,maxdeg,maxfact);
  Add (L,f);
od;
return L;
end;


RandomPolyListZeros := function(O,n,maxdeg,maxfact)
local f,i,L,Ox;

#Liste mit zufaelligen Polynomen nur ueber O.
#Mit mehr 0.
L:=[];
Ox := PolyAlg(O);
for i in [1..n] do
  f := RandomPolyZeros2(O,Ox,maxdeg,maxfact);
  Add (L,f);
od;
return L;
end;


RandomPolyListZ := function(O,n,maxdeg,maxfact)
local f,i,L,Ox;

#Liste mit zufaelligen Polynomen nur ueber O, aber Koeffizienten in Z.
L:=[];
Ox := PolyAlg(O);
for i in [1..n] do
  f := RandomPolyZ2(O,Ox,maxdeg,maxfact);
  Add (L,f);
od;
return L;
end;


RandomPolyListC := function(O,n,maxdeg,maxfact)
local f,i,L,Ox;

#Liste mit zufaelligen Polynomen nur ueber O, aber Faktoren ueber Z.
L:=[];
Ox := PolyAlg(O);
for i in [1..n] do
  f := RandomPolyC2(O,Ox,maxdeg,maxfact);
  Add (L,f);
od;
return L;
end;

